      subroutine tdpltprn (stdnew,stdout)
C
C  Routine for TDsw PLoT and PRiNt
C
C     written by: Stan Owocki and Glenn Cooper
C     date:       February, 1992
C
C  PURPOSE: Dumps VH-1 equivalent of tdsw.fin, tdsw.out and gmeta.2d
C
C  EXTERNALS:  TDPLT
C              TDPRNT
C
C  LOCALS:
C-----------------------------------------------------------------------
C
      include 'global.h'
      include 'zone.h'
C
      integer i, stdnew, stdout
      real rscale,vscale,dscale,xmscale,timscale,pscale,
     $   tscale,e2p

C\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\//////////////////////////////
C
C  Dump the restart variables.
C
      j = 1                  ! (for 1-D problem)
      k = 1
      rscale = rstar
      vscale=1.
      dscale = avgmass
      timscale=1.
      xmscale=1.
      pscale=1.
      tscale=1.
C
      open (unit=stdnew, file='vh1.fin')
      rewind stdnew
      write(stdnew,160) 6,imax,ncycle,time,rscale,vscale,
     $               dscale,xmscale,timscale,pscale
160    format(2i5,i10,1p4e22.14,1p2e10.3,1pe22.14)
      write(stdnew,162) (i, zxa(i)/rscale-1., zux(i,j,k)/vscale,
     $     zrho(i,j,k)/dscale,xmlag(i), zp(i,j,k)/pscale,zso(i,j,k),
     $     i=1,imax)
162    format(i5,1p6e22.14)
      close (stdnew)
C
c     call tdplt
      call tdprnt(stdout)
C
      return
      end
C
C--------------------------------------------------------------------
C
      subroutine tdprnt (stdout)
C
C PRiNT out Data at this Time step:
C
      include 'global.h'
      include 'zone.h'
C
      real flr, x,grsav(ii)
      real pr,temp,asnd
      real grad,gscat,gabs
      logical initflg
      integer stdout,ism1,iep1,iradfo,i,im1,ip1
      real secbyr,tmsob,e2p,gamma
      real zntf,z,vel,roi,den,vdrr,dr,dz,dm,dv,dvbdr
      real msol
      parameter (pi=3.141592654)
      data initflg /.true./

c      external radforf

      flr(x) = sign(max(abs(x),small),x)
C
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C
      j = 1
      k = 1
      e2p = gamm
      secbyr = 3.1557e7
      msol   = 1.99e33
      tmpcon = avgmass / boltzman
      if (initflg) call dumswpx
      initflg=.false.
C
C For CAK model, compute SSFFRC (and etarbc) for printout 
C
       do i=1,imax
          grsav(i) = zgr(i,j,k)
       enddo
       ovthba= vthba
       odt   = dt
       dt = 0.
       if ((ndim.eq.1).and.(vthba.le.0)) then
          vthba=.28
          call dumswpx
c      else if ((ndim.eq.1).and.(vthba.gt.0)) then
c         vthba=0.0
c         call dumswpx
       endif
       vthba= ovthba
       dt   = odt
C
C Print out data
C
c158    format(2i5,i10,1p3e18.10,1pe10.3,3i5)
158    format(2i5,i10,1p2e18.10,1p2e11.3,i5)
      dxvec=xvec(2)-xvec(1)
      if (xvec(1).eq.0.) xvec(1)=-6.3333
      if (dxvec.eq.0.) dxvec=0.3333
      if (nx.eq.0) nx=nxmax

c      write(6,*)'DHC (tdplt):',time
       write(6,158)
     $    9,imax,ncycle,time,dt,xvec(1),dxvec,nx
       write(stdout,158)
     $    9,imax,ncycle,time,dt,xvec(1),dxvec,nx
c     $    ncol,npts,istep,time,deltat,dtc,dtr,idtc,idtr,nx

      tmsob = 0.
      do i = 1, imax
c        if (shkflg) then
c           write(stdout,50) i,radn(i),rntf(i),flr(vntf(i)),
c    $                         flr(vzone(i)),rnew(i),pnew(i)
50          format(i5,1p1e16.8,1p8e11.3)
c        else
            zntf   = zxa(i)/rstar - 1.
            if (i.ne.imax) then
               z   = 0.5*(zxa(i) + zxa(i+1))/rstar - 1.
            else
               z   = (zxa(imax) + 0.5*zdx(imax))/rstar - 1.
            endif
            vel    = zux(i,j,k)
            den    = flr(zrho(i,j,k))
             if (i.ne.1) then
               roi = 0.5 * (zrho(i-1,j,k) + zrho(i,j,k))
               dv  = flr (vel - zux(i-1,j,k))
             else
               roi = zrho(i,j,k)     ! Don't mess with BC's here, for now
               dv  = flr (zux(i+1,j,k) - vel)
             endif
             xm     = xmlag(i)
             vdrr   = 4.*pi*(zxa(i)**2) * roi * vel
             vdrr   = vdrr * secbyr / msol
c            rnoi   = 0.5*flr(rold(i)+rold(im1))
c            vnoi   = rvold(i)/rnoi
             dr     = zdx(i)
             dz     = dr/rstar
             dm     = flr(roi*dr)
             dvbdr  = dv/dr
c            pr     = pnew(i)
             pr     = zp(i,j,k)
c            en     = enew(i)
c            asnd   = pr/den
c            temp   = asnd/rgscl
             temp   = tmpcon * pr/den
             asnd   = sqrt (gam * pr/den)
             grad  = grsav(i)
             gscat = zgs(i,j,k)
             gssf  = zgssf(i,j,k)
             gabs  = grad-gscat
             sf    = zesf(i,j,k)
             so    = zso(i,j,k)
c            gprs   = (pnew(im1)-pnew(i))/dm
c            ggrav  = gmmin/flr(rntf(i)*rntf(i))
c            gvis   = (qvis(im1)-qvis(i))/dm
c            gsum   = ggrav+grad+gprs+gvis
c            gcak   = fcak(i)/flr(roi(i))
c            gsob   = fsob(i)/flr(roi(i))
c            gdsk   = fdsk(i)/flr(roi(i))
c            gvdvdr = v*dvbdr
c            gpart  = (v-vnoi)/deltat
c            gadv   = (vhalf(i)-v)/deltat
c            gtot   = gpart + gvdvdr
c            gtot   = gpart + gadv
             xx     = xvec(i)
             etarbc = flr(esumr(i))
             if (i.gt.nx) etarbc=small
             tmofx  = max(xkapm*etarbc-1.,small)
c            emtau  = exp(-1.e-5*tmofx)
c            tmsobo = tmsob
c            tmsob  = xkapm*den*vth/flr(dvbdr)
c            htsob  = dz*(tmsob-tmsobo)*2/(tmsob+tmsobo)
c             write(6,*) i,ztauc(i,1,1)
             tauc   = ztauc(i,1,1)
                write(stdout,52) i,zntf,vel,den,xm,grad,tauc,
     $                             xx,tmofx,so      
c52             format(i5,1pe12.4,2e11.3,e14.6,5e11.3)
 52             format(i5,1p3e18.10,e14.6,5e11.3)
c        endif
      enddo
C
c      close (stdout)
      return
      end
C
C----------------------------------------------------------------------
C
      function simlev(lev)
      save lstore
C
C Function to get (lev<-1) or set(lev>1) disspla level.
C
      if (lev.gt.0) lstore = lev
      simlev = lstore
      return
      end
C
C----------------------------------------------------------------------
C
      subroutine siminit
C
C SDS v2.1 2/18/87
C
C  INITializes SIMplt package.
C
c     call opngks
      l=simlev(1)
c     call nochek
      return
      end
C
C----------------------------------------------------------------------
C
      subroutine simclr
C
C @(#)  simclr.f4p 1.1  12/9/80 20:19:19
C
C  advance frame (return to level 1):
C
c     call endpl(0)
      l=simlev(1)
      return
      end
C
C----------------------------------------------------------------------
C
      subroutine simfin
C
C MFE v1.0
C
C FINish SIMplt (returns to level 0):
C
C      call dendpl(0)
C      call endpl(0)
      l = simlev(1)
c     call donepl
c      call clsgks
c     call exit(1)
      end
C
C--------------------------------------------------------------------
C
      subroutine wrtime(istep,time)
C
C Write istep & time on plot
C
      return
      end
C
C--------------------------------------------------------------------
C
      subroutine dumswpx
C
C This subroutine performs dummy 1D hydro sweeps in the X direction,
C looping over j by k rows. Used by tdpltprn to initialize force, 
C without actually disturbing flow variables.
C
C-----------------------------------------------------------------------
C
C GLOBALS
C
      include 'global.h'
      include 'zone.h'
      include 'sweep.h'
C
C LOCALS
C
      integer i, j, k, n
      real paracoff( 9, maxsweep )
C
C-----------------------------------------------------------------------
      sweep = 'x'
C
C Add two ghost zones to 1D sweep arrays
      nmin = 3
      nmax = imax + 2
C
C Load up 1D array of grid coordinates (xa:Lagrangian, xa0:Eulerian)
      do 2 i = 1, imax
         n = i + 2
         xa (n) = zxa(i)
         dx (n) = zdx(i)
         xa0(n) = zxa(i)
         dx0(n) = zdx(i)
 2    continue
C
C Set coordinates in ghost zones before calling paraset to get coefficients
      dx(nmin-1) = dx(nmin)
      dx(nmin-2) = dx(nmin)
      xa(nmin-1) = xa(nmin)   - dx(nmin-1)
      xa(nmin-2) = xa(nmin-1) - dx(nmin-2)
      dx(nmax+1) = dx(nmax)
      dx(nmax+2) = dx(nmax)
      xa(nmax+1) = xa(nmax)   + dx(nmax)
      xa0(nmax+1)= xa(nmax+1)
      xa(nmax+2) = xa(nmax+1) + dx(nmax+1)
C
C Set up coefficients for parabola subroutine
      call paraset( paracoff, dx, xa, nmin, nmax, ngeomx )
C
C Now Loop over each row...
      radius = 1.
      do 1 k = 1, kmax
      do 1 j = 1, jmax
C
C Put state variables into 1D arrays, padding with 2 ghost zones
      do 10 i = 1,imax
         n = i + 2
         rho(n) = zrho(i,j,k)
         p  (n) = zp  (i,j,k)
         u  (n) = zux (i,j,k)
         v  (n) = zuy (i,j,k)
         w  (n) = zuz (i,j,k)
         xa (n) = zxa(i)
         dx (n) = zdx(i)
         p   (n) = max(smallp,p(n))
         enrg(n) = p(n)/rho(n)/gamm + 0.5*(u(n)**2+v(n)**2+w(n)**2)
 10   continue
      xa(nmax+1) = xa(nmax) + dx(nmax)
C
C Calculate volume element for given geometry
C
      if(ngeomx .eq. 0) then
         do 20 n = nmin, nmax
            dvol (n) = dx(n)
            dvol0(n) = dvol(n)
 20      continue
      else if(ngeomx .eq. 1) then
         do 21 n = nmin, nmax
            dvol (n) = dx(n) * (xa(n) + .5*dx(n))
            dvol0(n) = dvol(n)
 21      continue
      else if(ngeomx .eq. 2) then
         do 22 n = nmin, nmax
            dvol (n) = dx(n) * (xa(n)*(xa(n)+dx(n)) + dx(n)*dx(n)/3.)
            dvol0(n) = dvol(n)
 22      continue
      endif
C      
C First call sweepbc to impose boundary conditions,
C  then call ppm.f to evolve the flow in the 1D sweep,
C   then call sweepbc to impose boundary conditions again for remap,
C    then call remap.f to remap evolved quantities back to Eulerian grid.
C
      call sweepbc( nleftx, nrightx )
      call ppm    ( nleftx, nrightx, ngeomx, paracoff )
      call sweepbc( nleftx, nrightx )
      call remap  ( nleftx, nrightx, ngeomx )
C     
 1    continue
      return
      end
